searchData={"items":[{"type":"module","title":"TokenRefresher","doc":"TokenRefresher is responsible for continuously refreshing tokens\nfor multiple providers based on their `expires_in` configuration.","ref":"TokenRefresher.html"},{"type":"function","title":"TokenRefresher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TokenRefresher.html#child_spec/1"},{"type":"function","title":"TokenRefresher.get_token/1","doc":"Gets the current token for a given provider.","ref":"TokenRefresher.html#get_token/1"},{"type":"function","title":"Parameters - TokenRefresher.get_token/1","doc":"- provider: The provider module.","ref":"TokenRefresher.html#get_token/1-parameters"},{"type":"function","title":"Returns - TokenRefresher.get_token/1","doc":"- `{:ok, token}` if the token is found.\n  - `{:error, :not_found}` if the provider is not found.","ref":"TokenRefresher.html#get_token/1-returns"},{"type":"function","title":"TokenRefresher.start_link/1","doc":"Starts the TokenRefresher supervisor.","ref":"TokenRefresher.html#start_link/1"},{"type":"function","title":"Example - TokenRefresher.start_link/1","doc":"TokenRefresher.start_link()","ref":"TokenRefresher.html#start_link/1-example"},{"type":"behaviour","title":"TokenRefresher.Provider","doc":"A behaviour module for implementing token providers.","ref":"TokenRefresher.Provider.html"},{"type":"callback","title":"TokenRefresher.Provider.fetch_token/0","doc":"","ref":"TokenRefresher.Provider.html#c:fetch_token/0"},{"type":"module","title":"TokenRefresher.Refresher","doc":"","ref":"TokenRefresher.Refresher.html"},{"type":"function","title":"TokenRefresher.Refresher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TokenRefresher.Refresher.html#child_spec/1"},{"type":"function","title":"TokenRefresher.Refresher.start_link/1","doc":"Starts the Refresher GenServer.","ref":"TokenRefresher.Refresher.html#start_link/1"},{"type":"extras","title":"TokenRefresher","doc":"# TokenRefresher\n\nTokenRefresher is a library to manage and refresh tokens for multiple providers based on their expiration configuration.","ref":"readme.html"},{"type":"extras","title":"Installation - TokenRefresher","doc":"Add `token_refresher` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:token_refresher, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - TokenRefresher","doc":"Configure the providers in your application configuration:\n\n```elixir\nconfig :token_refresher, :providers, [\n  {MyApp.Provider1, 3600},\n  {MyApp.Provider2, 7200}\n]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - TokenRefresher","doc":"Implement the TokenRefresher.Provider behaviour in your provider modules:\n\n```elixir\ndefmodule MyApp.Provider1 do\n  @behaviour TokenRefresher.Provider\n\n  @impl true\n  def fetch_token do\n    # Logic to fetch the token\n    {:ok, \"new_token\"}\n  end\nend\n```\n\nStart the application:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      TokenRefresher\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\nNow TokenRefresher will periodically refresh tokens for the configured providers.","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}